
# Taking the recipe returns the array of sdates to be loaded
# both for the hcst and fcst.
dates2load <- function(recipe, logger){

  recipe <- recipe$params$Time
  
  # hcst dates

  file_dates <- paste0(strtoi(recipe$hcst_start):strtoi(recipe$hcst_end),
                       recipe$sdate$fcst_sday)
  file_dates <- add_dims(file_dates, "hcst")
  
  # fcst dates (if fcst_year empty it creates an empty object)
  if (! is.null(recipe$sdate$fcst_syear)){
    file_dates.fcst <- paste0(recipe$sdate$fcst_syear,recipe$sdate$fcst_sday)
    file_dates.fcst <- add_dims(file_dates.fcst, "fcst")
  } else {
    file_dates.fcst <- NULL
    info(logger,
         paste("fcst_year empty in the recipe, creating empty fcst object..."))
  }

  return(list(hcst=file_dates,fcst=file_dates.fcst))
  ## TODO: document header of fun

}

# adds the correspondent dims to each sdate array
add_dims <- function(data, type){

  if (type == "hcst"){
    default_dims <- c(sday = 1, sweek = 1, 
                      sdate = length(data))
  } else {
    default_dims <- c(fcst_syear = length(data))
  }

  default_dims[names(dim(data))] <- dim(data)
  dim(data) <- default_dims
  return(data)

 }



